blob: a75642bc4f366af6dee723d12dfdfdfd29d9a2a1 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Orion Hodson64fe3be2018-06-15 12:50:22 +010044export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000048export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000049export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070050export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070051
Alan Leungd5cbc562018-03-15 14:02:46 -070052# If d8 was not set by the environment variable, assume it is in the path.
53if [ -z "$D8" ]; then
54 export D8="d8"
55fi
56
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070057# If dx was not set by the environment variable, assume it is in the path.
58if [ -z "$DX" ]; then
Orion Hodson64fe3be2018-06-15 12:50:22 +010059 export DX="d8-compat-dx"
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070060fi
61
Orion Hodson64fe3be2018-06-15 12:50:22 +010062export DEXMERGER="$D8"
Alan Leungd5cbc562018-03-15 14:02:46 -070063
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080064# If jasmin was not set by the environment variable, assume it is in the path.
65if [ -z "$JASMIN" ]; then
66 export JASMIN="jasmin"
67fi
68
Andreas Gampe8fda9f22014-10-03 16:15:37 -070069# If smali was not set by the environment variable, assume it is in the path.
70if [ -z "$SMALI" ]; then
71 export SMALI="smali"
72fi
73
Sebastien Hertz19ac0272015-02-24 17:39:50 +010074# ANDROID_BUILD_TOP is not set in a build environment.
75if [ -z "$ANDROID_BUILD_TOP" ]; then
76 export ANDROID_BUILD_TOP=$oldwd
77fi
78
Dan Willemsen12371e92017-03-06 17:55:20 -080079# OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP.
80# Convert it to an absolute path, since we cd into the tmp_dir to run the tests.
81export OUT_DIR=${OUT_DIR:-out}
82if [[ "$OUT_DIR" != /* ]]; then
83 export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR
84fi
85
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086# ANDROID_HOST_OUT is not set in a build environment.
87if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsen12371e92017-03-06 17:55:20 -080088 export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070089fi
90
Alex Light680cbf22018-10-31 11:00:19 -070091host_lib_root=${ANDROID_HOST_OUT}
92
Igor Murashkine5181932017-06-15 16:03:50 -070093# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070094if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070095 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
96fi
97
Igor Murashkin271a0f82017-02-14 21:14:17 +000098# Zipalign is not on the PATH in some configs, auto-detect it.
99if [ -z "$ZIPALIGN" ]; then
100 if which zipalign >/dev/null; then
101 ZIPALIGN="zipalign";
102 else
103 # TODO: Add a dependency for zipalign in Android.run-test.mk
104 # once it doesn't depend on libandroidfw (b/35246701)
105 case "$OSTYPE" in
106 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
107 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
108 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
109 esac
110 fi
111fi
112export ZIPALIGN
113
David Brazdil122c6632018-01-24 17:32:49 +0000114# If hiddenapi was not set by the environment variable, assume it is in
115# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000116if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000117 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000118fi
119
Roland Levillain76cfe612017-10-30 13:14:28 +0000120chroot=
121
jeffhao5d1ac922011-09-29 17:41:15 -0700122info="info.txt"
123build="build"
124run="run"
125expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700126check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700127output="output.txt"
128build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100129cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700130strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700131lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700132testlib="arttestd"
Andreas Gampe11410de2019-07-02 15:53:53 -0700133run_args=(--quiet)
David Brazdil4846d132015-01-15 19:07:08 +0000134build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700135
Alex Light91de25f2015-10-28 17:00:06 -0700136quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000137debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700138prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700139target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700140dev_mode="no"
141update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700142debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000143relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800144runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700145usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700146build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700147suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700148trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700149trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700150basic_verify="false"
151gc_verify="false"
152gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700153jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700154jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700155jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700156jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700157strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700158always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700159never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700160have_image="yes"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000161android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700162bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800163suspend_timeout="500000"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000164image_suffix=""
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100165run_optimizing="false"
jeffhao5d1ac922011-09-29 17:41:15 -0700166
Alex Light20802ca2018-12-05 15:36:03 -0800167# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
168# ART output to approximately 128MB. This should be more than sufficient
169# for any test while still catching cases of runaway output.
170# Set a hard limit to encourage ART developers to increase the ulimit here if
171# needed to support a test case rather than resetting the limit in the run
172# script for the particular test in question. Adjust this if needed for
173# particular configurations.
174file_ulimit=128000
175
Andreas Gampe11410de2019-07-02 15:53:53 -0700176
jeffhao5d1ac922011-09-29 17:41:15 -0700177while true; do
178 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700179 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700180 DEX_LOCATION=$tmp_dir
Andreas Gampe11410de2019-07-02 15:53:53 -0700181 run_args+=(--host)
jeffhao5d1ac922011-09-29 17:41:15 -0700182 shift
Alex Light91de25f2015-10-28 17:00:06 -0700183 elif [ "x$1" = "x--quiet" ]; then
184 quiet="yes"
185 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700186 elif [ "x$1" = "x--use-java-home" ]; then
187 if [ -n "${JAVA_HOME}" ]; then
188 export JAVA="${JAVA_HOME}/bin/java"
189 export JAVAC="${JAVA_HOME}/bin/javac -g"
190 else
191 echo "Passed --use-java-home without JAVA_HOME variable set!"
192 usage="yes"
193 fi
194 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800195 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700196 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800197 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800198 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700199 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700200 NEED_DEX="false"
Andreas Gampe11410de2019-07-02 15:53:53 -0700201 run_args+=(--jvm)
jeffhao5d1ac922011-09-29 17:41:15 -0700202 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800203 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700204 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700205 testlib="arttest"
Andreas Gampe11410de2019-07-02 15:53:53 -0700206 run_args+=(-O)
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700207 shift
208 elif [ "x$1" = "x--dalvik" ]; then
209 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800210 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700211 shift
Alex Light03a112d2014-08-25 13:25:56 -0700212 elif [ "x$1" = "x--no-image" ]; then
213 have_image="no"
214 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700215 elif [ "x$1" = "x--relocate" ]; then
216 relocate="yes"
217 shift
218 elif [ "x$1" = "x--no-relocate" ]; then
219 relocate="no"
220 shift
221 elif [ "x$1" = "x--prebuild" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700222 run_args+=(--prebuild)
Alex Lighta59dd802014-07-02 16:28:08 -0700223 prebuild_mode="yes"
224 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800225 elif [ "x$1" = "x--compact-dex-level" ]; then
226 option="$1"
227 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700228 run_args+=("$option" "$1")
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800229 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700230 elif [ "x$1" = "x--strip-dex" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700231 run_args+=(--strip-dex)
Richard Uhler76f5cb62016-04-04 13:30:16 -0700232 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000233 elif [ "x$1" = "x--debuggable" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700234 run_args+=(-Xcompiler-option --debuggable)
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000235 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000236 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700237 elif [ "x$1" = "x--no-prebuild" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700238 run_args+=(--no-prebuild)
Alex Lighta59dd802014-07-02 16:28:08 -0700239 prebuild_mode="no"
240 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700241 elif [ "x$1" = "x--gcverify" ]; then
242 basic_verify="true"
243 gc_verify="true"
244 shift
245 elif [ "x$1" = "x--gcstress" ]; then
246 basic_verify="true"
247 gc_stress="true"
248 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700249 elif [ "x$1" = "x--jvmti-step-stress" ]; then
250 jvmti_step_stress="true"
251 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700252 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
253 jvmti_redefine_stress="true"
254 shift
Alex Light43e935d2017-06-19 15:40:40 -0700255 elif [ "x$1" = "x--jvmti-field-stress" ]; then
256 jvmti_field_stress="true"
257 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700258 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
259 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700260 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800261 elif [ "x$1" = "x--suspend-timeout" ]; then
262 shift
263 suspend_timeout="$1"
264 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700265 elif [ "x$1" = "x--image" ]; then
266 shift
267 image="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700268 run_args+=(--image "$image")
Elliott Hughes7c046102011-10-19 18:16:03 -0700269 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000270 elif [ "x$1" = "x-Xcompiler-option" ]; then
271 shift
272 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700273 run_args+=(-Xcompiler-option "$option")
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000274 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000275 elif [ "x$1" = "x--build-option" ]; then
276 shift
277 option="$1"
278 build_args="${build_args} $option"
279 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700280 elif [ "x$1" = "x--runtime-option" ]; then
281 shift
282 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700283 run_args+=(--runtime-option "$option")
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700284 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700285 elif [ "x$1" = "x--gdb-arg" ]; then
286 shift
287 gdb_arg="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700288 run_args+=(--gdb-arg "$gdb_arg")
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700289 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700290 elif [ "x$1" = "x--debug" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700291 run_args+=(--debug)
jeffhao5d1ac922011-09-29 17:41:15 -0700292 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700293 elif [ "x$1" = "x--debug-wrap-agent" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700294 run_args+=(--debug-wrap-agent)
Alex Lightc281ba52017-10-11 11:35:55 -0700295 shift
Alex Light0e151e72017-10-25 10:50:35 -0700296 elif [ "x$1" = "x--with-agent" ]; then
297 shift
298 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700299 run_args+=(--with-agent "$1")
Alex Light0e151e72017-10-25 10:50:35 -0700300 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700301 elif [ "x$1" = "x--debug-agent" ]; then
302 shift
303 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700304 run_args+=(--debug-agent "$1")
Alex Lightc281ba52017-10-11 11:35:55 -0700305 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700306 elif [ "x$1" = "x--gdb" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700307 run_args+=(--gdb)
jeffhao5d1ac922011-09-29 17:41:15 -0700308 dev_mode="yes"
309 shift
Alex Lighte4b4a182019-02-12 14:19:49 -0800310 elif [ "x$1" = "x--gdbserver-bin" ]; then
311 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700312 run_args+=(--gdbserver-bin "$1")
Alex Lighte4b4a182019-02-12 14:19:49 -0800313 shift
314 elif [ "x$1" = "x--gdbserver-port" ]; then
315 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700316 run_args+=(--gdbserver-port "$1")
Alex Lighte4b4a182019-02-12 14:19:49 -0800317 shift
318 elif [ "x$1" = "x--gdbserver" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700319 run_args+=(--gdbserver)
Alex Lighte4b4a182019-02-12 14:19:49 -0800320 dev_mode="yes"
321 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700322 elif [ "x$1" = "x--strace" ]; then
323 strace="yes"
Andreas Gampe11410de2019-07-02 15:53:53 -0700324 run_args+=(--timeout 1800 --invoke-with strace --invoke-with -o --invoke-with "$tmp_dir/$strace_output")
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700325 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700326 elif [ "x$1" = "x--zygote" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700327 run_args+=(--zygote)
jeffhao5d1ac922011-09-29 17:41:15 -0700328 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800329 elif [ "x$1" = "x--interpreter" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700330 run_args+=(--interpreter)
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700331 image_suffix="-interpreter"
332 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800333 elif [ "x$1" = "x--jit" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700334 run_args+=(--jit)
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000335 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800336 shift
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100337 elif [ "x$1" = "x--baseline" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700338 run_args+=(--baseline)
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100339 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700340 elif [ "x$1" = "x--optimizing" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100341 run_optimizing="true"
jeffhao0dff3f42012-11-20 15:13:43 -0800342 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700343 elif [ "x$1" = "x--no-verify" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700344 run_args+=(--no-verify)
jeffhao5d1ac922011-09-29 17:41:15 -0700345 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700346 elif [ "x$1" = "x--verify-soft-fail" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700347 run_args+=(--verify-soft-fail)
Andreas Gampe825570c2015-07-26 10:26:03 -0700348 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700349 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700350 elif [ "x$1" = "x--no-optimize" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700351 run_args+=(--no-optimize)
jeffhao5d1ac922011-09-29 17:41:15 -0700352 shift
353 elif [ "x$1" = "x--no-precise" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700354 run_args+=(--no-precise)
jeffhao5d1ac922011-09-29 17:41:15 -0700355 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700356 elif [ "x$1" = "x--invoke-with" ]; then
357 shift
358 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700359 if [ "x$what" = "x" ]; then
360 echo "$0 missing argument to --invoke-with" 1>&2
361 usage="yes"
362 break
363 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700364 run_args+=(--invoke-with "${what}")
jeffhao5d1ac922011-09-29 17:41:15 -0700365 shift
366 elif [ "x$1" = "x--dev" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700367 run_args+=(--dev)
jeffhao5d1ac922011-09-29 17:41:15 -0700368 dev_mode="yes"
369 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700370 elif [ "x$1" = "x--build-only" ]; then
371 build_only="yes"
372 shift
373 elif [ "x$1" = "x--output-path" ]; then
374 shift
375 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700376 if [ "x$tmp_dir" = "x" ]; then
377 echo "$0 missing argument to --output-path" 1>&2
378 usage="yes"
379 break
380 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700381 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000382 elif [ "x$1" = "x--chroot" ]; then
383 shift
384 if [ "x$1" = "x" ]; then
385 echo "$0 missing argument to --chroot" 1>&2
386 usage="yes"
387 break
388 fi
389 chroot="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700390 run_args+=(--chroot "$1")
Roland Levillain76cfe612017-10-30 13:14:28 +0000391 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000392 elif [ "x$1" = "x--android-root" ]; then
393 shift
394 if [ "x$1" = "x" ]; then
395 echo "$0 missing argument to --android-root" 1>&2
396 usage="yes"
397 break
398 fi
399 android_root="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700400 run_args+=(--android-root "$1")
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000401 shift
Roland Levillain28076142019-01-10 16:39:25 +0000402 elif [ "x$1" = "x--android-runtime-root" ]; then
403 shift
404 if [ "x$1" = "x" ]; then
405 echo "$0 missing argument to --android-runtime-root" 1>&2
406 usage="yes"
407 break
408 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700409 run_args+=(--android-runtime-root "$1")
Roland Levillain28076142019-01-10 16:39:25 +0000410 shift
Roland Levillain90b34572019-06-14 15:23:15 +0100411 elif [ "x$1" = "x--android-tzdata-root" ]; then
412 shift
413 if [ "x$1" = "x" ]; then
414 echo "$0 missing argument to --android-tzdata-root" 1>&2
415 usage="yes"
416 break
417 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700418 run_args+=(--android-tzdata-root "$1")
Roland Levillain90b34572019-06-14 15:23:15 +0100419 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700420 elif [ "x$1" = "x--update" ]; then
421 update_mode="yes"
422 shift
423 elif [ "x$1" = "x--help" ]; then
424 usage="yes"
425 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700426 elif [ "x$1" = "x--64" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700427 run_args+=(--64)
Andreas Gampe2fe07922014-04-21 07:50:39 -0700428 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700429 shift
Alex Light680cbf22018-10-31 11:00:19 -0700430 elif [ "x$1" = "x--bionic" ]; then
431 # soong linux_bionic builds are 64bit only.
Andreas Gampe11410de2019-07-02 15:53:53 -0700432 run_args+=(--bionic --host --64)
Alex Light680cbf22018-10-31 11:00:19 -0700433 suffix64="64"
434 target_mode="no"
435 DEX_LOCATION=$tmp_dir
436 host_lib_root=$OUT_DIR/soong/host/linux_bionic-x86
437 shift
Alex Light6f342dd2019-03-27 17:15:42 +0000438 elif [ "x$1" = "x--runtime-extracted-zipapex" ]; then
439 shift
440 # TODO Should we allow the java.library.path to search the zipapex too?
441 # Not needed at the moment and adding it will be complicated so for now
442 # we'll ignore this.
Andreas Gampe11410de2019-07-02 15:53:53 -0700443 run_args+=(--host --runtime-extracted-zipapex "$1")
Alex Light6f342dd2019-03-27 17:15:42 +0000444 target_mode="no"
445 DEX_LOCATION=$tmp_dir
446 shift
Alex Light20802ca2018-12-05 15:36:03 -0800447 elif [ "x$1" = "x--runtime-zipapex" ]; then
448 shift
449 # TODO Should we allow the java.library.path to search the zipapex too?
450 # Not needed at the moment and adding it will be complicated so for now
451 # we'll ignore this.
Andreas Gampe11410de2019-07-02 15:53:53 -0700452 run_args+=(--host --runtime-zipapex "$1")
Alex Light20802ca2018-12-05 15:36:03 -0800453 target_mode="no"
454 DEX_LOCATION=$tmp_dir
455 # apex_payload.zip is quite large we need a high enough ulimit to
456 # extract it. 512mb should be good enough.
457 file_ulimit=512000
458 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200459 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700460 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200461 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700462 elif [ "x$1" = "x--stream" ]; then
463 trace_stream="true"
464 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700465 elif [ "x$1" = "x--always-clean" ]; then
466 always_clean="yes"
467 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700468 elif [ "x$1" = "x--never-clean" ]; then
469 never_clean="yes"
470 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800471 elif [ "x$1" = "x--dex2oat-swap" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700472 run_args+=(--dex2oat-swap)
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800473 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700474 elif [ "x$1" = "x--instruction-set-features" ]; then
475 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700476 run_args+=(--instruction-set-features "$1")
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700477 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700478 elif [ "x$1" = "x--bisection-search" ]; then
479 bisection_search="yes"
480 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000481 elif [ "x$1" = "x--vdex" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700482 run_args+=(--vdex)
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000483 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000484 elif [ "x$1" = "x--dm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700485 run_args+=(--dm)
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000486 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000487 elif [ "x$1" = "x--vdex-filter" ]; then
488 shift
489 filter=$1
Andreas Gampe11410de2019-07-02 15:53:53 -0700490 run_args+=(--vdex-filter "$filter")
Nicolas Geoffray74981052017-01-16 17:54:09 +0000491 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700492 elif [ "x$1" = "x--random-profile" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700493 run_args+=(--random-profile)
Jeff Hao002b9312017-03-27 16:23:08 -0700494 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700495 elif [ "x$1" = "x--dex2oat-jobs" ]; then
496 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700497 run_args+=(-Xcompiler-option "-j$1")
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700498 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700499 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700500 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700501 usage="yes"
502 break
503 else
504 break
505 fi
506done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700507
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100508if [ "$usage" = "no" -a "x$1" = "x" ]; then
509 echo "missing test to run" 1>&2
510 usage="yes"
511fi
512
Roland Levillain76cfe612017-10-30 13:14:28 +0000513# The DEX_LOCATION with the chroot prefix, if any.
514chroot_dex_location="$chroot$DEX_LOCATION"
515
Alex Light91de25f2015-10-28 17:00:06 -0700516# Allocate file descriptor real_stderr and redirect it to the shell's error
517# output (fd 2).
518if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
519 exec {real_stderr}>&2
520else
521 # In bash before version 4.1 we need to do a manual search for free file
522 # descriptors.
523 FD=3
524 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
525 real_stderr=$FD
526 eval "exec ${real_stderr}>&2"
527fi
528if [ "$quiet" = "yes" ]; then
529 # Force the default standard output and error to go to /dev/null so we will
530 # not print them.
531 exec 1>/dev/null
532 exec 2>/dev/null
533fi
534
535function err_echo() {
536 echo "$@" 1>&${real_stderr}
537}
538
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700539# tmp_dir may be relative, resolve.
540#
541# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000542# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700543# Cannot use readlink -m, as it does not exist on Mac.
544# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700545noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700546tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700547mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700548
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800549# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000550if [ ! "$runtime" = "jvm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700551 run_args+=(--runtime-option "-XX:ThreadSuspendTimeout=$suspend_timeout")
Narayan Kamathf86c3932017-01-24 17:40:47 +0000552fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800553
Alex Lighte7873ec2014-08-12 09:53:50 -0700554if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800555 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
Andreas Gampe11410de2019-07-02 15:53:53 -0700556 run_args+=(--runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0)
Alex Lighte7873ec2014-08-12 09:53:50 -0700557fi
558if [ "$gc_verify" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700559 run_args+=(--runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc)
Alex Lighte7873ec2014-08-12 09:53:50 -0700560fi
561if [ "$gc_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700562 run_args+=(--gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m)
Alex Lighte7873ec2014-08-12 09:53:50 -0700563fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700564if [ "$jvmti_redefine_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700565 run_args+=(--no-app-image --jvmti-redefine-stress)
Alex Lightb7edcda2017-04-27 13:20:31 -0700566fi
Alex Lightc38c3692017-06-27 15:45:14 -0700567if [ "$jvmti_step_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700568 run_args+=(--no-app-image --jvmti-step-stress)
Alex Lightc38c3692017-06-27 15:45:14 -0700569fi
Alex Light43e935d2017-06-19 15:40:40 -0700570if [ "$jvmti_field_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700571 run_args+=(--no-app-image --jvmti-field-stress)
Alex Light43e935d2017-06-19 15:40:40 -0700572fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700573if [ "$jvmti_trace_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700574 run_args+=(--no-app-image --jvmti-trace-stress)
Alex Light8f2c6d42017-04-10 16:27:35 -0700575fi
Jeff Hao85139a32014-07-23 11:52:52 -0700576if [ "$trace" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700577 run_args+=(--runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000)
Andreas Gampe7526d782015-06-22 22:53:45 -0700578 if [ "$trace_stream" = "true" ]; then
579 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
580 # the ability to analyze the file and just write to /dev/null.
Andreas Gampe11410de2019-07-02 15:53:53 -0700581 run_args+=(--runtime-option -Xmethod-trace-file:/dev/null)
Andreas Gampe7526d782015-06-22 22:53:45 -0700582 # Enable streaming mode.
Andreas Gampe11410de2019-07-02 15:53:53 -0700583 run_args+=(--runtime-option -Xmethod-trace-stream)
Andreas Gampe7526d782015-06-22 22:53:45 -0700584 else
Andreas Gampe11410de2019-07-02 15:53:53 -0700585 run_args+=(--runtime-option "-Xmethod-trace-file:${DEX_LOCATION}/trace.bin")
Andreas Gampe7526d782015-06-22 22:53:45 -0700586 fi
587elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700588 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700589 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700590fi
591
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700592# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000593# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100594function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700595 # Check whether this is a device with native bridge. Currently this is hardcoded
596 # to x86 + arm.
597 x86_arm=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | sort | grep -E '^(arm|x86)$'`
598 # Collapse line-breaks into spaces
599 x86_arm=$(echo $x86_arm)
600 if [ "x$x86_arm" = "xarm x86" ] ; then
601 err_echo "Native-bridge configuration detected."
602 # We only support the main arch for tests.
603 if [ "x${suffix64}" = "x64" ]; then
604 target_arch_name=""
605 else
606 target_arch_name=x86
607 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700608 else
Andreas Gamped0566d42018-06-06 09:54:34 -0700609 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
610 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
611 if [ "x${suffix64}" = "x64" ]; then
612 target_arch_name=${grep64bit}
613 else
614 target_arch_name=${grep32bit}
615 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700616 fi
617}
618
David Brazdil853a4c32015-09-28 16:15:50 +0100619function guess_host_arch_name() {
620 if [ "x${suffix64}" = "x64" ]; then
621 host_arch_name="x86_64"
622 else
623 host_arch_name="x86"
624 fi
625}
626
Alex Lighta59dd802014-07-02 16:28:08 -0700627if [ "$target_mode" = "no" ]; then
628 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700629 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700630 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000631 exit 1
632 fi
633 else
634 # ART/Dalvik host mode.
635 if [ -n "$chroot" ]; then
636 err_echo "--chroot with --host is unsupported"
637 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700638 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700639 fi
640fi
641
Jeff Hao201803f2013-11-20 18:11:39 -0800642if [ ! "$runtime" = "jvm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700643 run_args+=(--lib "$lib")
Jeff Hao201803f2013-11-20 18:11:39 -0800644fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700645
Jeff Hao201803f2013-11-20 18:11:39 -0800646if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700647 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000648 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800649 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Andreas Gampe11410de2019-07-02 15:53:53 -0700650 run_args+=(--boot --runtime-option "-Xbootclasspath:${bpath}")
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700651 else
652 true # defaults to using target BOOTCLASSPATH
653 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800654elif [ "$runtime" = "art" ]; then
655 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100656 guess_host_arch_name
Andreas Gampe11410de2019-07-02 15:53:53 -0700657 run_args+=(--boot "${ANDROID_HOST_OUT}/framework/core${image_suffix}.art")
658 run_args+=(--runtime-option "-Djava.library.path=${host_lib_root}/lib${suffix64}:${host_lib_root}/nativetest${suffix64}")
Jeff Hao201803f2013-11-20 18:11:39 -0800659 else
David Brazdil853a4c32015-09-28 16:15:50 +0100660 guess_target_arch_name
Andreas Gampe11410de2019-07-02 15:53:53 -0700661 run_args+=(--runtime-option "-Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}")
662 run_args+=(--boot "/data/art-test/core${image_suffix}.art")
Jeff Hao201803f2013-11-20 18:11:39 -0800663 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700664 if [ "$relocate" = "yes" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700665 run_args+=(--relocate)
Alex Lighta59dd802014-07-02 16:28:08 -0700666 else
Andreas Gampe11410de2019-07-02 15:53:53 -0700667 run_args+=(--no-relocate)
Alex Lighta59dd802014-07-02 16:28:08 -0700668 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700669elif [ "$runtime" = "jvm" ]; then
670 # TODO: Detect whether the host is 32-bit or 64-bit.
Andreas Gampe11410de2019-07-02 15:53:53 -0700671 run_args+=(--runtime-option "-Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64")
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700672fi
673
Alex Light03a112d2014-08-25 13:25:56 -0700674if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700675 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700676 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700677 exit 1
678 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700679 run_args+=(--no-image)
Alex Light03a112d2014-08-25 13:25:56 -0700680fi
681
jeffhao5d1ac922011-09-29 17:41:15 -0700682if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700683 err_echo "--dev and --update are mutually exclusive"
684 usage="yes"
685fi
686
687if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
688 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700689 usage="yes"
690fi
691
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700692if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
693 err_echo "--bisection-search and --prebuild are mutually exclusive"
694 usage="yes"
695fi
696
Roland Levillain76cfe612017-10-30 13:14:28 +0000697# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
698if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
699 err_echo "--chroot with --bisection-search is unsupported"
700 exit 1
701fi
702
jeffhao5d1ac922011-09-29 17:41:15 -0700703if [ "$usage" = "no" ]; then
704 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
705 test_dir=`basename "$oldwd"`
706 else
707 test_dir="$1"
708 fi
709
710 if [ '!' -d "$test_dir" ]; then
711 td2=`echo ${test_dir}-*`
712 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700713 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700714 usage="yes"
715 fi
716 test_dir="$td2"
717 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700718 # Shift to get rid of the test name argument. The rest of the arguments
719 # will get passed to the test run.
720 shift
721fi
722
723if [ "$usage" = "yes" ]; then
724 prog=`basename $prog`
725 (
726 echo "usage:"
727 echo " $prog --help Print this message."
728 echo " $prog [options] [test-name] Run test normally."
729 echo " $prog --dev [options] [test-name] Development mode" \
730 "(dumps to stdout)."
731 echo " $prog --update [options] [test-name] Update mode" \
732 "(replaces expected.txt)."
733 echo ' Omitting the test name or specifying "-" will use the' \
734 "current directory."
735 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000736 echo " -O Run non-debug rather than debug build (off by default)."
737 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000738 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000739 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800740 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700741 echo " --debug Wait for the default debugger to attach."
742 echo " --debug-agent <agent-path>"
743 echo " Wait for the given debugger agent to attach. Currently"
744 echo " only supported on host."
745 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
746 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700747 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000748 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000749 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lighte4b4a182019-02-12 14:19:49 -0800750 echo " --gdbserver Start gdbserver (defaults to port :5039)."
751 echo " --gdbserver-port <port>"
752 echo " Start gdbserver with the given COMM (see man gdbserver)."
753 echo " --gdbserver-bin <binary>"
754 echo " Use the given binary as gdbserver."
755 echo " --gdb-arg Pass an option to gdb or gdbserver."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000756 echo " --build-only Build test files only (off by default)."
757 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800758 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000759 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000760 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700761 echo " --verify-soft-fail Force soft fail verification (off by default)."
762 echo " Verification is enabled if neither --no-verify"
763 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000764 echo " --no-optimize Turn off optimization (on by default)."
765 echo " --no-precise Turn off precise GC (on by default)."
766 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700767 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000768 echo " other runtime options are ignored."
769 echo " --no-dex2oat Run as though dex2oat was failing."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000770 echo " --prebuild Run dex2oat on the files before starting test. (default)"
771 echo " --no-prebuild Do not run dex2oat on the files before starting"
772 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700773 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000774 echo " --relocate Force the use of relocating in the test, making"
775 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000776 echo " address before running."
777 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700778 echo " --image Run the test using a precompiled boot image. (default)"
779 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000780 echo " --host Use the host-mode virtual machine."
781 echo " --invoke-with Pass --invoke-with option to runtime."
782 echo " --dalvik Use Dalvik (off by default)."
783 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700784 echo " --use-java-home Use the JAVA_HOME environment variable"
785 echo " to find the java compiler and runtime"
786 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000787 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700788 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000789 echo " --64 Run the test in 64-bit mode"
Alex Light680cbf22018-10-31 11:00:19 -0700790 echo " --bionic Use the (host, 64-bit only) linux_bionic libc runtime"
Alex Light20802ca2018-12-05 15:36:03 -0800791 echo " --runtime-zipapex [file]"
792 echo " Use the given zipapex file to provide runtime binaries"
Alex Light6f342dd2019-03-27 17:15:42 +0000793 echo " --runtime-extracted-zipapex [dir]"
794 echo " Use the given extracted zipapex directory to provide"
795 echo " runtime binaries"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000796 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700797 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700798 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000799 echo " --gcstress Run with gc stress testing"
800 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700801 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700802 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700803 echo " --jvmti-redefine-stress"
804 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000805 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700806 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000807 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000808 echo " --android-root [path] The path on target for the android root. (/system by default)."
Victor Chang64611242019-07-05 16:32:41 +0100809 echo " --android-i18n-root [path]"
810 echo " The path on target for the i18n module root."
811 echo " (/apex/com.android.i18n by default)."
Roland Levillain28076142019-01-10 16:39:25 +0000812 echo " --android-runtime-root [path]"
813 echo " The path on target for the Android Runtime root."
814 echo " (/apex/com.android.runtime by default)."
Roland Levillain90b34572019-06-14 15:23:15 +0100815 echo " --android-tzdata-root [path]"
816 echo " The path on target for the Android Time Zone Data root."
817 echo " (/apex/com.android.tzdata by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000818 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700819 echo " --instruction-set-features [string]"
820 echo " Set instruction-set-features for compilation."
Alex Light91de25f2015-10-28 17:00:06 -0700821 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700822 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000823 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800824 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700825 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700826 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700827 exit 1
828fi
829
830cd "$test_dir"
831test_dir=`pwd`
832
833td_info="${test_dir}/${info}"
834td_expected="${test_dir}/${expected}"
835
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700836if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700837 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700838 exit 1
839fi
840
841if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700842 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700843 exit 1
844fi
845
846# copy the test to a temp dir and run it
847
Elliott Hughes510c8782011-10-06 10:57:34 -0700848echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700849
850rm -rf "$tmp_dir"
Alex Light0aa7a5a2018-10-10 15:58:14 +0000851cp -LRp "$test_dir" "$tmp_dir"
jeffhao5d1ac922011-09-29 17:41:15 -0700852cd "$tmp_dir"
853
854if [ '!' -r "$build" ]; then
855 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800856else
857 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700858fi
859
860if [ '!' -r "$run" ]; then
861 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800862else
863 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700864fi
865
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700866if [ '!' -r "$check_cmd" ]; then
867 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800868else
869 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700870fi
871
jeffhao5d1ac922011-09-29 17:41:15 -0700872chmod 755 "$build"
873chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700874chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700875
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700876export TEST_NAME=`basename ${test_dir}`
877
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000878# Tests named '<number>-checker-*' will also have their CFGs verified with
879# Checker when compiled with Optimizing on host.
880if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100881 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$run_optimizing" = "true" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000882 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
883 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
884 run_checker="yes"
885
886 if [ "$target_mode" = "no" ]; then
887 cfg_output_dir="$tmp_dir"
888 checker_args="--arch=${host_arch_name^^}"
889 else
890 cfg_output_dir="$DEX_LOCATION"
891 checker_args="--arch=${target_arch_name^^}"
892 fi
893
894 if [ "$debuggable" = "yes" ]; then
895 checker_args="$checker_args --debuggable"
896 fi
897
Andreas Gampe11410de2019-07-02 15:53:53 -0700898 run_args+=(-Xcompiler-option "--dump-cfg=$cfg_output_dir/$cfg_output" -Xcompiler-option -j1)
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000899 fi
900 fi
901fi
902
Andreas Gampe11410de2019-07-02 15:53:53 -0700903run_args+=(--testlib "${testlib}")
Mathieu Chartier031768a2015-08-27 10:25:02 -0700904
Alex Light20802ca2018-12-05 15:36:03 -0800905if ! ulimit -f ${file_ulimit}; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000906 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700907fi
908
Igor Murashkin2de6e082018-02-28 15:25:23 -0800909# Tell the build script which mode (target, host, jvm) we are building for
910# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000911if [[ "$target_mode" == "yes" ]]; then
912 build_args="$build_args --target"
913else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800914 if [[ $runtime == "jvm" ]]; then
915 build_args="$build_args --jvm"
916 else
917 build_args="$build_args --host"
918 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000919fi
920
921if [[ "$dev_mode" == "yes" ]]; then
922 build_args="$build_args --dev"
923fi
924
jeffhao5d1ac922011-09-29 17:41:15 -0700925good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000926good_build="yes"
927good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700928export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700929if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000930 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700931 build_exit="$?"
932 echo "build exit status: $build_exit" 1>&2
933 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800934 echo "${test_dir}: running..." 1>&2
Andreas Gampe11410de2019-07-02 15:53:53 -0700935 "./${run}" "${run_args[@]}" "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700936 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000937
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800938 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000939 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100940 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000941 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100942 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100943 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000944 checker_exit="$?"
945 if [ "$checker_exit" = "0" ]; then
946 good="yes"
947 fi
Alex Light91de25f2015-10-28 17:00:06 -0700948 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000949 else
950 good="yes"
951 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800952 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000953 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700954 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700955elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000956 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700957 build_exit="$?"
958 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800959 echo "${test_dir}: running..." 1>&2
Andreas Gampe11410de2019-07-02 15:53:53 -0700960 "./${run}" "${run_args[@]}" "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000961 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100962 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +0000963 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100964 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100965 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000966 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700967 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
968 good="yes"
969 else
Alex Light91de25f2015-10-28 17:00:06 -0700970 cat "$build_output" 1>&${real_stderr} 1>&2
971 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700972 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700973elif [ "$build_only" = "yes" ]; then
974 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000975 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700976 build_exit="$?"
977 if [ "$build_exit" '!=' '0' ]; then
978 cp "$build_output" "$output"
979 echo "build exit status: $build_exit" >>"$output"
980 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
981 if [ "$?" '!=' "0" ]; then
982 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700983 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700984 fi
985 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700986 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700987 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700988 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700989else
David Brazdil4846d132015-01-15 19:07:08 +0000990 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700991 build_exit="$?"
992 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800993 echo "${test_dir}: running..." 1>&2
Andreas Gampe11410de2019-07-02 15:53:53 -0700994 "./${run}" "${run_args[@]}" "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000995 run_exit="$?"
996 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700997 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000998 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000999 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001000 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001001 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001002 fi
David Brazdil5cc343d2015-10-08 11:35:32 +01001003 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +00001004 checker_exit="$?"
1005 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -07001006 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +00001007 good_run="no"
1008 else
1009 good_run="yes"
1010 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001011 else
1012 good_run="yes"
1013 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001014 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001015 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -07001016 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -07001017 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
1018 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -07001019 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -07001020 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -07001021 max_name_length=$(getconf NAME_MAX ${tmp_dir})
1022 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
1023 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -07001024 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -07001025 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -07001026 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -07001027 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001028 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
1029 # output == expected
1030 good="yes"
1031 echo "${test_dir}: succeeded!" 1>&2
1032 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001033 fi
1034fi
1035
jeffhao5d1ac922011-09-29 17:41:15 -07001036(
Alex Lightbfac14a2014-07-30 09:41:21 -07001037 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -07001038 echo "${test_dir}: FAILED!"
1039 echo ' '
1040 echo '#################### info'
1041 cat "${td_info}" | sed 's/^/# /g'
1042 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -07001043 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -07001044 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001045 if [ "$strace" = "yes" ]; then
1046 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -07001047 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001048 echo '####################'
1049 fi
Andreas Gampee79ca192017-07-31 10:30:16 -07001050 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
1051 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
1052 # tools used by the given ABI work for both x86 and x86-64.
1053 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
1054 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001055 echo ' '
1056 fi
Alex Lightbfac14a2014-07-30 09:41:21 -07001057
Alex Light91de25f2015-10-28 17:00:06 -07001058) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -07001059
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001060# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +00001061# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001062if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
1063 # Bisecting works by skipping different optimization passes which breaks checker assertions.
1064 if [ "$run_checker" == "yes" ]; then
1065 echo "${test_dir}: not bisecting, checker test." 1>&2
1066 else
1067 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001068 echo "${test_dir}: bisecting..." 1>&2
1069 cwd=`pwd`
1070 maybe_device_mode=""
1071 raw_cmd=""
1072 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001073 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001074 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1075 # to exec in order to preserve pid when calling dalvikvm. This is required
1076 # for bisection search to correctly retrieve logs from device.
Andreas Gampe11410de2019-07-02 15:53:53 -07001077 "./${run}" "${run_args[@]}" --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001078 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001079 maybe_device_mode="--device"
1080 raw_cmd="$DEX_LOCATION/cmdline.sh"
1081 else
Andreas Gampe11410de2019-07-02 15:53:53 -07001082 raw_cmd="$cwd/${run} --external-log-tags "${run_args[@]}" $@"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001083 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001084 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001085 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1086 $maybe_device_mode \
1087 --raw-cmd="$raw_cmd" \
1088 --check-script="$cwd/check" \
1089 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001090 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001091 --timeout=300
1092 fi
1093fi
1094
Alex Lightbfac14a2014-07-30 09:41:21 -07001095# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001096if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001097 cd "$oldwd"
1098 rm -rf "$tmp_dir"
1099 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001100 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001101 fi
1102 if [ "$good" = "yes" ]; then
1103 exit 0
1104 fi
1105fi
1106
1107
1108(
1109 if [ "$always_clean" = "yes" ]; then
1110 echo "${TEST_NAME} files deleted from host "
1111 if [ "$target_mode" == "yes" ]; then
1112 echo "and from target"
1113 fi
1114 else
1115 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1116 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001117 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001118 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001119 fi
1120
Alex Light91de25f2015-10-28 17:00:06 -07001121) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001122
Alex Light6a870fa2016-05-31 16:36:19 -07001123if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1124 exit 0
1125else
1126 exit 1
1127fi